// watchtools.h
// Mark Buchanan

#include <stdio.h>

#define WATCH_ON
//#define WATCH_ONELINE




//MACROS

//Debug
#ifdef WATCH_ONELINE
	#define WATCH_SEP "\t\t"
#else
	#define WATCH_SEP "\n"
#endif

#ifdef WATCH_ON
	#define WATCH_BOOL(  b )	printf( "%s: %s%s", #b, b ? "YES" : "NO", WATCH_SEP );
	#define WATCH_INT(   i )	printf( "%s: %d%s", #i, (int)(i), WATCH_SEP );
	#define WATCH_UINT(  ui )	printf( "%s: %u%s",#ui, (unsigned int)(ui), WATCH_SEP );
	#define WATCH_FLOAT( f )	printf( "%s: %f%s", #f, f, WATCH_SEP );
	#define WATCH_STR(   s )	printf( "%s: %s%s", #s, s, WATCH_SEP );
	#define WATCH_PTR(   p )	printf( "%s: %p%s", #p, p, WATCH_SEP );
	#define WATCH_VEC(   v )	printf( "%s: % f % f % f%s", #v, v.x, v.y, v.z, WATCH_SEP );
	#define WATCH_VEC2(  v )	printf( "%s:\t[%.4f , %.4f]%s", #v, v.x, v.y,	WATCH_SEP );
	#define WATCH_FMT( fmt, arg )	{ printf( "%s: ", #arg ); printf( fmt, arg ); printf( WATCH_SEP ); }
	#define WATCH( arg )		{ printf( "%s", arg ); printf( WATCH_SEP ); }
	#define WATCH_FUNC			printf( "%s%s", __FUNCTION__, WATCH_SEP );
	#define WATCH_FUNCCOUNT		{	static int count = 0;	printf( "%s: %d%s", __FUNCTION__, count, WATCH_SEP );	count++;	}
	#define WATCH_END			printf( "\n" );
#else
	#define WATCH_BOOL(  b )	
	#define WATCH_INT(   i )	
	#define WATCH_UINT(  ui )
	#define WATCH_FLOAT( f )	
	#define WATCH_STR(   s )	
	#define WATCH_VEC(   v )	
	#define WATCH_FMT( fmt, arg )	
	#define WATCH_VEC2(  v )
	#define WATCH( arg )	
	#define WATCH_FUNC
	#define WATCH_FUNCCOUNT
	#define WATCH_END
#endif









